#include <iostream>
#include <vector>

  using namespace std;
  #define isgolos(c)(c=='a'||c=='e'||c=='i'||c=='o'||c=='u'||c=='y'||c=='A'||c=='E'||c=='I'||c=='O'||c=='U'||c=='Y')
  class Node {
    char data;
    Node *left;
    Node *right;
  public:
    Node() : data(0), left(nullptr), right(nullptr) {}
    
    Node(char data) : data(data), left(nullptr), right(nullptr) {}
    void insert(char data) {
      if (data < this->data) {
        if (left == nullptr) {
          left = new Node(data);
        } else {
          left->insert(data);
        }
      } else {
        if (right == nullptr) {
          right = new Node(data);
        } else {
          right->insert(data);
        }
      }
    }
    
    ~Node() {
      if (left != nullptr) {
        delete left;
      }
      if (right != nullptr) {
        delete right;
      }
    }
    void display(int depth = 0) const {
        if (right != nullptr) {
            right->display(depth + 1);
        }
        for (int i = 0; i < depth; i++) {
            cout << "  ";
        }
        cout << data << endl;
    
        if (left != nullptr) {
            left->display(depth + 1);
        }
    }
    void mixed(vector<char> &result) const {
      if (left != nullptr) {
          left->mixed(result);
      }
  
      result.push_back(data);
  
      if (right != nullptr) {
          right->mixed(result);
      }
    }
    char check(char find){
      if (data==find) return true;
      if (find<data&&left!=nullptr&&left->check(find)) return true;
      if (find>data&&right!=nullptr&&right->check(find)) return true;
      return false;
    }
    char getdata(){
      return data;
    }
    bool trickydisplay(char find){
      if (left!=nullptr){
          if (left->getdata()==find){
          cout<<"Parent: "<<data<<endl;
          left->display(1);
        return 1;}}
      if (right!=nullptr){
          if (right->getdata()==find){
          cout<<"Parent: "<<data<<endl;
          right->display(1);
        return 1;}}
      if (left!=nullptr) if(left->trickydisplay(find))return 1;
      if (right!=nullptr) if(right->trickydisplay(find))return 1;
      return 0;
    }
  };
  
  #define menu "e: exit"<<endl<<"i: input"<<endl<<"d: display"<<endl<<"o: obhid"<<endl<<"c: check"<<endl<<"t: tricky dsplay"<<endl
  int main() {
    Node *root = nullptr;
    char input;
    while (true) {
      cout<<menu;
      cin >> input;
      if (input == 'e') {
        break;
      }
      else if (input == 'd') {
          if(root){
        cout<<"===================="<<endl;
        root->display();
        cout<<"===================="<<endl;
            }
        continue;
      }
      else if (input == 'i') {
        cin >> input;
      if (root == nullptr) {
        root = new Node(input);
      } else {
        root->insert(input);
      }
    }
    else if (input == 'o') {
      vector<char> result;
      if(root)
      root->mixed(result);
      char golos=0;
      for (char c : result) {
        cout << c;
        if (c==*(result.rbegin()))cout<<endl;else cout<<' ';
        if (golos>-1&&golos<3){
        if (isgolos(c)) golos++;
        if (golos>2)
            golos=c;
      }}
      if (golos>2&&golos!=-1){
        cout << "Third golos: " << golos << endl;
      golos=-1;
    }}
      else if (input == 'c') {
        cin >> input;
        if (root->check(input)) cout<<"Yes"<<endl;
        else cout<<"No"<<endl;
      }
      else if (input == 't'){
          cout << "Enter char" << endl;
          cin >> input;
          if(root){
            if(root->getdata()==input){cout<<"No parent for this node!"<<endl;
            root->display();}
            else if(!root->trickydisplay(input))cout<<"No such node!"<<endl;
              }
        }
      }
    delete root;
    return 0;
  }
